' CDTP.inc
' CLASS definitions

AUTODEFINE "OFF"

$INCLUDE "udts.inc"

' Enum Const values used to recognise the type of Graphic for files
ENUM G_TYPE
	CBASE = 1
	CRECT
	CCIRCLE
	CELLIPSE
ENDENUM

'--------------------------------------------------------------------------

' BASE CLASS
CLASS CDTPObject
	DECLARE CDTPObject()
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw(pointer win)
	DECLARE VIRTUAL WriteFile(Pointer gf)
	DECLARE VIRTUAL ReadFile(Pointer gf)
PROTECTED
	G_TYPE m_gType
	UINT m_fgcol, m_bgcol
ENDCLASS

'--------------------------------------------------------------------------

' RECTANGLE CLASS (derived class) - inherits CDTPObject (Base Class)
CLASS CDTPRect, CDTPObject
	DECLARE CDTPRect()
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw(pointer win)
	DECLARE VIRTUAL WriteFile(Pointer gf)
	DECLARE VIRTUAL ReadFile(Pointer gf)
PROTECTED
	INT m_left, m_top, m_width, m_height, m_LineWidth
	ISTRING m_LineStyle[20]
ENDCLASS

'--------------------------------------------------------------------------

' ELLIPSE CLASS (derived class) - inherits CDTPObject (Base Class)
'CLASS CDTPEllipse, CDTPRect, CDTPObject - not implemented in EB
CLASS CDTPEllipse, CDTPObject
	DECLARE CDTPEllipse()
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw(pointer win)
	DECLARE VIRTUAL WriteFile(Pointer gf)
	DECLARE VIRTUAL ReadFile(Pointer gf)
PROTECTED
	' Members same as those in CDTPRect ...
	INT m_left, m_top, m_width, m_height, m_LineWidth
	ISTRING m_LineStyle[20]
ENDCLASS

'--------------------------------------------------------------------------

' CIRCLE CLASS (derived class) - inherits CDTPObject (Base Class)
CLASS CDTPCircle, CDTPObject
	DECLARE CDTPCircle()
	DECLARE VIRTUAL SetParam(pointer obj)
	DECLARE VIRTUAL Draw(pointer win)
	DECLARE VIRTUAL WriteFile(Pointer gf)
	DECLARE VIRTUAL ReadFile(Pointer gf)
PROTECTED
	INT m_x, m_y, m_radius, m_LineWidth
	ISTRING m_LineStyle[20]
ENDCLASS

'--------------------------------------------------------------------------
